<script setup lang="ts">
import RemoveButton from "@/components/organisms/button/RemoveButton.vue";
import Textarea from "@/components/atoms/input/Textarea.vue";
import {useShortcutsListenerStore} from "@/stores/Shortcuts/ShortcutsListenerStore";
import {computed} from "vue";
import {findShortcutWithCode, SHORTCUTS} from "@/constants/SHORTCUTS_PER_SECTION";
import TextContainer from "@/components/atoms/container/TextContainer.vue";

const props = defineProps<{
  content: String,
  onRemove: Function,
  onInput: Function,
  addContentFunction: Function,
  goToNextContent: Function,
  goToPreviousContent: Function,
  moveUpContentLine: Function,
  moveDownContentLine: Function,
  disabled?: undefined|Boolean
}>()

const shortcutListener = useShortcutsListenerStore();
const removeContentShortcut = computed(() => findShortcutWithCode(SHORTCUTS.REMOVE_LINE));
const addContentShortcut = computed(() => findShortcutWithCode(SHORTCUTS.ADD_LINE));
const previousShortcut = computed(() => findShortcutWithCode(SHORTCUTS.PREVIOUS_LINE));
const nextShortcut = computed(() => findShortcutWithCode(SHORTCUTS.NEXT_LINE));
const moveUpShortcut = computed(() => findShortcutWithCode(SHORTCUTS.MOVE_LINE_UP));
const moveDownShortcut = computed(() => findShortcutWithCode(SHORTCUTS.MOVE_LINE_DOWN));

function listenShortcut(event: KeyboardEvent) {
  if (removeContentShortcut.value?.isValidEvent(event)) {
    props.onRemove();
  } else if (addContentShortcut.value?.isValidEvent(event)) {
    props.addContentFunction();
  } else if (previousShortcut.value?.isValidEvent(event)) {
    props.goToPreviousContent();
  } else if (nextShortcut.value?.isValidEvent(event)) {
    props.goToNextContent();
  } else if (moveUpShortcut.value?.isValidEvent(event)) {
    props.moveUpContentLine();
  } else if (moveDownShortcut.value?.isValidEvent(event)) {
    props.moveDownContentLine();
  }
}
</script>

<template>
  <TextContainer no-wrap class="items-center">
    <span>-</span>
    <span v-if="disabled">{{ content }}</span>
    <Textarea
        class="block p-input w-full text-xs"
        :value="content"
        autogrow
        @input="(event) => onInput(event.target.value)"
        @focus="() => shortcutListener.addListener(listenShortcut)"
        @blur="() => shortcutListener.removeListener(listenShortcut)"
        v-if="!disabled"
    />
    <RemoveButton @click="onRemove" v-if="!disabled"/>
  </TextContainer>
</template>
